unit HintUnit;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls,
  CE_Unit;

type
  THintForm = class(TForm)
    Bevel1: TBevel;
    OKBtn: TBitBtn;
    CalcelBtn: TBitBtn;
    ColorDialog1: TColorDialog;
    GroupBox1: TGroupBox;
    ShowHintsCB: TCheckBox;
    Label1: TLabel;
    HintElapseEdit: TEdit;
    Label2: TLabel;
    HintDurationEdit: TEdit;
    GroupBox2: TGroupBox;
    ColorBtn: TBitBtn;
    Shape1: TShape;
    RestoreBtn: TBitBtn;
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RestoreBtnClick(Sender: TObject);
    procedure CalcelBtnClick(Sender: TObject);
    procedure ColorDialog1Show(Sender: TObject);
    procedure ColorBtnClick(Sender: TObject);
  private
    { Private declarations }
    HoldHintColor : TColor;
  public
    { Public declarations }
  end;

var
  HintForm: THintForm;

implementation

uses MainUnit;

{$R *.DFM}

procedure THintForm.Label1Click(Sender: TObject);
begin
  HintElapseEdit.SetFocus;
end;

procedure THintForm.Label2Click(Sender: TObject);
begin
  HintDurationEdit.SetFocus;
end;

procedure THintForm.FormShow(Sender: TObject);
begin
  with Application do begin
    ShowHintsCB.Checked := ShowHint;
    HintElapseEdit.Text := IntToStr (HintPause);
    HintDurationEdit.Text := IntToStr (HintHidePause);
    Shape1.Brush.Color := HintColor;
    HoldHintColor := HintColor;
  end;
end;

procedure THintForm.OKBtnClick(Sender: TObject);
begin
  with Application do begin
    ShowHint := ShowHintsCB.Checked;
    HintPause := Int (HintElapseEdit.Text );
    HintHidePause := Int (HintDurationEdit.Text);
  end;
end;

procedure THintForm.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorBtn.Click;
end;

procedure THintForm.RestoreBtnClick(Sender: TObject);
begin
  Application.HintColor := clInfoBk;
  Shape1.Brush.Color := Application.HintColor;
end;

procedure THintForm.CalcelBtnClick(Sender: TObject);
begin
  Application.HintColor := HoldHintColor;
end;

procedure THintForm.ColorDialog1Show(Sender: TObject);
begin
  ColorDialog1.Color := Shape1.Brush.Color;
end;

procedure THintForm.ColorBtnClick(Sender: TObject);
begin
  if ColorDialog1.Execute then begin
    Shape1.Brush.Color := ColorDialog1.Color;
    Application.HintColor := Shape1.Brush.Color;
  end;
end;









end.

