unit OrderUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TOrderForm = class(TForm)
    ListBox1: TListBox;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    SortBtn: TBitBtn;
    UpBtn: TButton;
    DownBtn: TButton;
    procedure SortBtnClick(Sender: TObject);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure UpBtnClick(Sender: TObject);
    procedure DownBtnClick(Sender: TObject);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
  private
    { Private declarations }
    function SwapItems (Item : integer) : boolean;
  public
    { Public declarations }
    MainItem : integer;
  end;

var
  OrderForm: TOrderForm;

implementation

{$R *.DFM}

function TOrderForm.SwapItems (Item : integer) : boolean;

  function Valid (i : integer) : boolean;
  begin
    result := (i >= 0) and (i < ListBox1.Items.Count);
  end;

  var s : string;

begin
  with ListBox1 do begin
    result := (ItemIndex <> Item) and Valid (ItemIndex)
      and Valid (Item);
    if not result then exit;

    s := Items[ItemIndex];
    Items[ItemIndex] := Items[Item];
    Items[Item] := s;

  if MainItem = ItemIndex then
    MainItem := Item
  else if MainItem = Item then
    MainItem := ItemIndex;

    ItemIndex := Item;
  end;//with...
end;

procedure TOrderForm.SortBtnClick(Sender: TObject);

  function MainItemExists : boolean;
  begin
    result := (MainItem >= 0) and (MainItem < ListBox1.Items.Count);
  end;

var hMainItem : string;
begin
  if MainItemExists then
    hMainItem := ListBox1.Items[MainItem];

  ListBox1.Sorted := true;
  ListBox1.Sorted := false;

  if MainItemExists then begin
    //put MainItem at top of sort
    ListBox1.Items.Delete (ListBox1.Items.IndexOf (hMainItem));
    ListBox1.Items.Insert (0, hMainItem);
    MainItem := 0;
  end;
end;

procedure TOrderForm.ListBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  SwapItems (ListBox1.ItemAtPos (Point (X, Y), true));
end;

procedure TOrderForm.UpBtnClick(Sender: TObject);
begin
  with ListBox1 do
    if ItemIndex = 0 then
      SwapItems (Items.Count - 1)
    else if not SwapItems (ItemIndex - 1) then
      ItemIndex := 0;
end;

procedure TOrderForm.DownBtnClick(Sender: TObject);
begin
  with ListBox1 do
    if ItemIndex = Items.Count - 1 then
      SwapItems (0)
    else if not SwapItems (ItemIndex + 1) then
      ItemIndex := Items.Count - 1;
end;

procedure TOrderForm.ListBox1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  {needs remark because for some reason that makes
   drag work right}
end;

end.
